config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'home#index'

  resources :users, only: [:show] do
  	get 'shared_projects', on: :member
	  resources :projects, only: [:index, :new, :create]
    resources :trashes, only: [:index]
    resources :notifications, only: [:index, :destroy]
  end

  resources :projects, only: [:show, :edit, :update, :destroy] do
  	resources :tasks, only: [:new, :create, :index]
  	resources :contributors, only: [:new, :create, :index, :destroy]

    resources :links, only: [:new, :create] do
      get 'unlink', on: :member
    end

    resources :trashes, only: [:create] do
      collection { post 'restore', to: 'trashes#restore' }
    end
  end

  resources :tasks, only: [:edit, :update, :show] do
    resources :assignees, only: [:new, :create]
    post 'start', to: 'task_states#start'
    post 'ready', to: 'task_states#ready'
    post 'finish', to: 'task_states#finish'
    post 'accept', to: 'task_states#accept'
    post 'schedule', to: 'task_states#schedule'
    post 'stop', to: 'task_states#stop'
    post 'continue', to: 'task_states#continue'
    post 'verify', to: 'task_states#verify'
    post 'reject', to: 'task_states#reject'
    post 'discard', to: 'task_states#discard'
  end

  resources :links, only: [:destroy]
end

app/models/user.rb
# frozen_string_literal: true
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :projects
  has_many :task_reports

  has_many :project_contributors
  has_many :third_person_projects, through: :project_contributors,
                                   source: :project

  has_many :task_contributors
  has_many :working_tasks, through: :task_contributors,
                           source: :task

  validates :name, uniqueness: true
end

app/controllers/users_controller.rb
# frozen_string_literal: true
class UsersController < ApplicationController
  layout 'logged_layout'

  before_action :authenticate_user!
  before_action :find_notifications

  def show
    @user = current_user
  end

  def shared_projects
    @projects = current_user.third_person_projects.map { |project| TimeDisplayPresenter.new(project) }
  end
end

app/views/users/_no_shared_project.html.erb
<section class="row">
  <div class="col-md-8 col-md-offset-2 col-sm-10 col-sm-offset-1 col-xs-10 col-xs-offset-1">
    <div class="text-center">
      <h3><%= t('user.no_shared_project') %></h3>
      <br />
    </div>
  </div>
</section>

app/views/users/shared_projects.html.erb
<article id='shared_projects'>
  <header class="row">
    <div class="text-center">
      <h1><%= t('user.shared_projects') %></h1>
      <hr>
    </div>
  </header>

	<% if @projects.empty? %>
		<%= render partial: 'no_shared_project' %>
	<% else %>
		<%= render partial: 'projects/project_summary', 
							 collection: @projects, as: :project %>
	<% end %>
</article>

app/views/users/show.html.erb
<section id='projects'>
  <div class="row">
    <div class="col-md-6 col-sm-8 col-xs-10">
      <h1>Hello, <%= @user.name %></h1>
      <hr>
    </div>
  </div>
  <div class="row">
    <div class="col-md-3 col-sm-6 col-xs-12">
      <%= link_to new_user_project_path(@user), class: 'btn btn-default', id: 'new_project' do %>
        <%= image_tag 'project.png', class: 'img-responsive' %>
        <h4><%= t('project.new') %></h4>
      <% end %>
    </div>

    <div class="col-md-3 col-sm-6 col-xs-12">
      <%= link_to  user_projects_path(current_user), class: 'btn btn-default', id: 'my_projects' do %>
        <%= image_tag 'my_projects.png', class: 'img-responsive' %>
        <h4><%= t('user.projects') %></h4>
      <% end %>
    </div>

    <div class="col-md-3 col-sm-6 col-xs-12">
      <%= link_to shared_projects_user_path(current_user), class: 'btn btn-default', id: 'shared_projects' do %>
        <%= image_tag 'shared_projects.png', class: 'img-responsive' %>
        <h4><%= t('user.shared_projects') %></h4>
      <% end %>
    </div>

    <div class="col-md-3 col-sm-6 col-xs-12">
      <%= link_to user_trashes_path(current_user), class: 'btn btn-default', id: 'trash' do %>
        <%= image_tag 'trash.png', class: 'img-responsive' %>
        <h4><%= t('user.trash') %></h4>
      <% end %>
    </div>
  </div>
</section>